'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

require('babel-polyfill');

var _tmServiceApi = require('tm-service-api');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Dummy Micro Service API that you may adopt for your needs
 *
 * @namespace DummyService
 * @module DummyService
 * @class
 * @exports
 *
 * @param {string} url - service url
 * @param {string | null} [token = null] - user access tocken if available
 * @see https://jsonplaceholder.typicode.com/
 */
var DummyService = function (_TMMicroServiceAPI) {
  _inherits(DummyService, _TMMicroServiceAPI);

  function DummyService() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    _classCallCheck(this, DummyService);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DummyService.__proto__ || Object.getPrototypeOf(DummyService)).call.apply(_ref, [this].concat(args))), _this), _this.get = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var result, json;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _get(DummyService.prototype.__proto__ || Object.getPrototypeOf(DummyService.prototype), 'request', _this).call(_this, _this.url + 'posts');

            case 2:
              result = _context.sent;
              _context.next = 5;
              return result.json();

            case 5:
              json = _context.sent;
              return _context.abrupt('return', json);

            case 7:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    })), _this.post = function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(title, body) {
        var options, result, json;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                options = {
                  method: 'POST',
                  headers: {
                    Accept: 'application/json',
                    'Content-Type': 'application/json'
                  },
                  body: JSON.stringify({
                    title: title,
                    body: body
                  })
                };
                _context2.next = 3;
                return _get(DummyService.prototype.__proto__ || Object.getPrototypeOf(DummyService.prototype), 'request', _this).call(_this, _this.url + 'posts', options);

              case 3:
                result = _context2.sent;
                _context2.next = 6;
                return result.json();

              case 6:
                json = _context2.sent;
                return _context2.abrupt('return', json);

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this2);
      }));

      return function (_x, _x2) {
        return _ref3.apply(this, arguments);
      };
    }(), _this.details = function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(id) {
        var response, json;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return _get(DummyService.prototype.__proto__ || Object.getPrototypeOf(DummyService.prototype), 'request', _this).call(_this, _this.url + 'posts/' + id);

              case 2:
                response = _context3.sent;

                if (!response.ok) {
                  _context3.next = 8;
                  break;
                }

                _context3.next = 6;
                return response.json();

              case 6:
                json = _context3.sent;
                return _context3.abrupt('return', json);

              case 8:
                if (!(response.status === 404)) {
                  _context3.next = 10;
                  break;
                }

                throw new _tmServiceApi.ErrorNotFound(DummyService.messages.postNotFound);

              case 10:
                throw new _tmServiceApi.ErrorServerResponse(response.status, response.statusText);

              case 11:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, _this2);
      }));

      return function (_x3) {
        return _ref4.apply(this, arguments);
      };
    }(), _temp), _possibleConstructorReturn(_this, _ret);
  }
  /**
   * Object with class service messages
   * @type {Object}
   */


  /**
   * Get posts list
   *
   * @method get
   * @async
   * @public
   * @memberof DummyService
   *
   * @return {PostList} - array of posts
   *
   * @example <caption>Read posts list</caption>
   * (async () => {
   *   const Dummy = new DummyService('https://jsonplaceholder.typicode.com/');
   *   const list = await Dummy.get();
   * })();
   */


  /**
   * Create post
   *
   * @method post
   * @async
   * @public
   * @memberof DummyService
   *
   * @param {string} title - post title
   * @param {string} body - post body
   * @return {Post} - created post
   *
   * @example <caption>Create post</caption>
   * (async () => {
   *   const Dummy = new DummyService('https://jsonplaceholder.typicode.com/');
   *   const details = await Dummy.post('My Title', 'My Text');
   * })();
   */


  /**
   * Posts list object
   *
   * @namespace DummyService
   * @typedef {PostList} Array of posts
   *
   * @property {Array.<Post>} - array of posts
   */

  /**
   * Post object
   *
   * @namespace DummyService
   * @typedef {Post} Post representation
   *
   * @property {number} id - post id
   * @property {string} title - post title
   * @property {string} body - post body
   */

  /**
   * Read specific post
   *
   * @method details
   * @memberof DummyService
   * @async
   * @public
   *
   * @param {number} id - post id
   * @return {Post} - post content
   *
   * @example <caption>Get post</caption>
   * (async () => {
   *   const Dummy = new DummyService('https://jsonplaceholder.typicode.com/');
   *   const details = await Dummy.details(2);
   * })();
   */


  return DummyService;
}(_tmServiceApi.TMMicroServiceAPI);

DummyService.messages = {
  postNotFound: 'Post not found'
};
exports.default = DummyService;
//# sourceMappingURL=index.js.map